#ifndef OVM_TASK_H
#define OVM_TASK_H

#include "base.h"

typedef struct {
	guint scenario;
	guint64 timestamp;
	guint in_size, out_size;
	gdouble *in, *out, *in_old;
	int tracefd;
	gboolean finished;
} task_t;

task_t* task_new(guint scenario);
void task_free(task_t *task);

void task_trace_start(task_t *task, const gchar *tracefile);
void task_trace_end(task_t *task);
void task_trace_step(task_t *task);

void ovm_init();
void ovm_step(guint scenario, gdouble *in, gdouble *out);
extern const guint ovm_outs, ovm_ins;

#endif